package turkov.math.algorithms;
import java.util.Random;
import turkov.lang.TUStringBuilder;

/*
 This abstract class is for calculating distances between any two sequences of data.
 */
public abstract class TUDistanceMeasures
{
    // add additional distance measures here
    public final static String LONGEST_COMMON_SUBSEQUENCE = "LONGEST_COMMON_SUBSEQUENCE";
    
    /*
     Main distance function method. Use this method to get the distance between two
     data sequences provided a supported distance function. 
     
     @param a the first squence
     @param b the second sequence
     @param method the distance method (function) to use to compare a and b.
     
     @return the distance between a and b using this suggested distance method.
     */
    public static double getDistance(Object[] a, Object[] b, String method)
    throws UnsupportedOperationException
    {
        double temp = 0;
        if(method.equals(LONGEST_COMMON_SUBSEQUENCE))
            temp = TULCS.getLengthOfLongestCommonSubsequence(a, b);
        
        else
            throw new UnsupportedOperationException
                    ("Unsupported distance method requested: " + method);    
        
        return (Math.sqrt(a.length * b.length) ) / (temp + 1);
    }
    
  
}